SystemOrganization addCategory: #TusLibrosDotCom!

Magnitude subclass: #MonthOfYear
	instanceVariableNames: 'monthNumber yearNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!MonthOfYear class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 10:32'!
januaryOf: aYearNumber

	^ self onMonthNumber: 1 of: aYearNumber  
	
	! !

!MonthOfYear class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 10:32'!
onMonthNumber: aMonthNumber of: aYearNumber

	^ self new initializeOnMonthNumber: aMonthNumber of: aYearNumber! !

!MonthOfYear methodsFor: 'comparing' stamp: 'HernanWilkinson 6/7/2012 11:56'!
< aMonthOfYear

	^ yearNumber < aMonthOfYear yearNumber  or: [ yearNumber = aMonthOfYear yearNumber and: monthNumber < aMonthOfYear monthNumber ]! !

!MonthOfYear methodsFor: 'comparing' stamp: 'HernanWilkinson 6/7/2012 11:40'!
= anObject

	^ (anObject isKindOf: self class) and: [ monthNumber = anObject monthNumber and: [ yearNumber = anObject yearNumber ]]! !

!MonthOfYear methodsFor: 'comparing' stamp: 'HernanWilkinson 6/7/2012 11:44'!
hash

	^ monthNumber hash bitXor: yearNumber hash! !

!MonthOfYear methodsFor: 'initialization' stamp: 'HernanWilkinson 6/7/2012 11:42'!
initializeOnMonthNumber: aMonthNumber of: aYearNumber

	monthNumber := aMonthNumber.
	yearNumber := aYearNumber! !

!MonthOfYear methodsFor: 'month' stamp: 'HernanWilkinson 6/7/2012 11:40'!
monthNumber
	
	^ monthNumber! !

!MonthOfYear methodsFor: 'year' stamp: 'HernanWilkinson 6/7/2012 11:41'!
yearNumber
	
	^ yearNumber! !

TestCase subclass: #CreditCardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:32'!
test01CanCreateACreditCardWithValidOwnerNameNumberAndExpirationDate

	self 
		shouldnt: [ CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate ]
		raise: Error 
		! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:33'!
test02CreditCardRemembersTheOwnerName

	self assert: (CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate) ownerName = self validOwnerName ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:34'!
test03CreditCardRemembersTheNumber

	self assert: (CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate) number = self validNumber! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:44'!
test04CreditCardRemembersTheExpirationDate

	self assert: (CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate) expirationDate = self validExpirationDate ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:51'!
test05CanNotCreateACreditCardWithEmptyOwnerName

	self 
		should: [ CreditCard ownedBy:'' identifiedBy: self validNumber expiresOn: self validExpirationDate ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText  = CreditCard invalidOwnerNameErrorDescription ]! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:51'!
test06CanNotCreateACreditCardWithBlanksOwnerName

	self 
		should: [ CreditCard ownedBy:'  ' identifiedBy: self validNumber expiresOn: self validExpirationDate ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText  = CreditCard invalidOwnerNameErrorDescription ]! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:53'!
test07OwnerNameGetsTrimmed

	self assert: (CreditCard ownedBy: ' pepe ' identifiedBy:  self validNumber expiresOn: self validExpirationDate ) ownerName = 'pepe'! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 12:03'!
test08ACreditCardIsExpiredIfTheCurrentMonthOfYearIsBiggerThanExpirationDate

	| expirationDate currentMonthOfYear |
	
	expirationDate := MonthOfYear onMonthNumber: 1 of: 2012.
	currentMonthOfYear := MonthOfYear onMonthNumber: 2 of:  2012. 
	self assert: ((CreditCard ownedBy: self validOwnerName identifiedBy:  self validNumber expiresOn: expirationDate ) isExpiredOn: currentMonthOfYear) ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 12:03'!
test09ACreditCardIsNotExpiredIfTheCurrentMonthOfYearIsEqualToExpirationDate

	self deny: ((CreditCard ownedBy: self validOwnerName identifiedBy:  self validNumber expiresOn: self validExpirationDate ) isExpiredOn: self validExpirationDate ) ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 12:04'!
test10ACreditCardIsNotExpiredIfTheCurrentMonthOfYearIsLessThanExpirationDate

	| expirationDate currentMonthOfYear |
	
	expirationDate := MonthOfYear onMonthNumber: 1 of: 2012.
	currentMonthOfYear := MonthOfYear onMonthNumber: 12 of:  2011. 
	self deny: ((CreditCard ownedBy: self validOwnerName identifiedBy:  self validNumber expiresOn: expirationDate ) isExpiredOn: currentMonthOfYear) ! !

!CreditCardTest methodsFor: 'test objects' stamp: 'HernanWilkinson 6/7/2012 10:31'!
validExpirationDate
	
	^ MonthOfYear januaryOf: 2012! !

!CreditCardTest methodsFor: 'test objects' stamp: 'HernanWilkinson 6/7/2012 10:30'!
validNumber
	
	 ^ '0123456789012345'! !

!CreditCardTest methodsFor: 'test objects' stamp: 'HernanWilkinson 6/7/2012 10:30'!
validOwnerName

	^ 'Pepe Sanchez'! !

TestCase subclass: #MonthOfYearTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:39'!
test01DifferentObjectsAreEqualIfTheyRepresentTheSameMonthOfYear

	self assert: (MonthOfYear onMonthNumber: 1 of: 2012) = (MonthOfYear onMonthNumber: 1 of: 2012)! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:42'!
test02DifferentObjectsAreNotEqualfTheyDoNotRepresentTheSameMonthOfYear

	self deny: (MonthOfYear onMonthNumber: 2 of: 2012) = (MonthOfYear onMonthNumber: 1 of: 2012)! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:43'!
test03DifferentObjectsThatAreEqualHaveTheSameHash

	self assert: (MonthOfYear onMonthNumber: 1 of: 2012) hash = (MonthOfYear onMonthNumber: 1 of: 2012) hash! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:54'!
test04AMonthOfYearIsLessThanOtherIfTheYearIsLess

	self assert: (MonthOfYear onMonthNumber: 1 of: 2011) < (MonthOfYear onMonthNumber: 1 of: 2012) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:57'!
test05AMonthOfYearIsLessThanOtherIfTheYearIsEqualButTheMonthIsLess

	self assert: (MonthOfYear onMonthNumber: 1 of: 2011) < (MonthOfYear onMonthNumber: 2 of: 2011) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:58'!
test06AMonthOfYearIsNotLessThanOtherIfTheyAreEqual

	self deny: (MonthOfYear onMonthNumber: 1 of: 2011) < (MonthOfYear onMonthNumber: 1 of: 2011) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:58'!
test07AMonthOfYearIsNotLessThanOtherIfTheYearIsBigger

	self deny: (MonthOfYear onMonthNumber: 1 of: 2012) < (MonthOfYear onMonthNumber: 1 of: 2011) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:59'!
test08AMonthOfYearIsNotLessThanOtherIfTheYearIsEqualButTheMonthIsBigger

	self deny: (MonthOfYear onMonthNumber: 2 of: 2011) < (MonthOfYear onMonthNumber: 1 of: 2011) ! !

TestCase subclass: #TusLibrosDotComTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'MaximilianoBalmaceda 6/18/2012 20:55'!
aCashier
	"Por el momento creamos una cajera sin merchant processor, ya que todava no se va a usar"

	^ Cashier newWithMerchantProcessor: nil andSalesBook: self aSalesBook.! !

!TusLibrosDotComTest methodsFor: 'catalogue object' stamp: 'MaximilianoBalmaceda 6/18/2012 20:45'!
aCatalogue

	| catalogue |
	catalogue := Dictionary new.
	catalogue at: '11111' put: 5; at: '22222' put: 3.5.
	^catalogue.


! !

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'Balmaceda 6/27/2012 02:06'!
aClock

	^DateAndTime! !

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'GabrielFinkelstein 6/17/2012 18:39'!
aNonEmptyCart

	^self anEmptyCart addItem: '11111' withQuantity: 1.


! !

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'MaximilianoBalmaceda 6/18/2012 20:56'!
aSalesBook

	^Set new.! !

!TusLibrosDotComTest methodsFor: 'credit card object' stamp: 'MaximilianoBalmaceda 6/18/2012 20:22'!
aValidCreditCard

	^CreditCard ownedBy: 'Juan' identifiedBy: 'Perez' expiresOn: (MonthOfYear januaryOf: Date today year + 2 )


! !

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'GabrielFinkelstein 6/17/2012 18:49'!
anEmptyCart

	^ShoppingCart newWithCatalogue: self aCatalogue.


! !

!TusLibrosDotComTest methodsFor: 'credit card object' stamp: 'MaximilianoBalmaceda 6/18/2012 20:22'!
anExpiredCreditCard

	^CreditCard ownedBy: 'Juan' identifiedBy: 'Perez' expiresOn: (MonthOfYear januaryOf: Date today year - 2)


! !

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'Balmaceda 6/27/2012 04:28'!
registeredUsers

| registeredUsers |

	registeredUsers := Dictionary new.
	registeredUsers at:'12345' put:'pwd12345'.
	registeredUsers at:'23456' put:'pwd23456'.
	^registeredUsers.! !

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'Balmaceda 6/27/2012 04:29'!
restInterface

	^RESTInterface newWithCatalogue: self aCatalogue andClock: self aClock andRegisteredUsers: self registeredUsers.! !

!TusLibrosDotComTest methodsFor: 'shopping cart object' stamp: 'Balmaceda 6/27/2012 04:29'!
restInterfaceWithClock: aClock

	^RESTInterface newWithCatalogue: self aCatalogue andClock: aClock andRegisteredUsers: self registeredUsers.! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/17/2012 17:46'!
test01ANewCartShouldBeEmpty

	self assert: self anEmptyCart isEmpty.


! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/17/2012 17:46'!
test02AddingItemsToCartShouldReturnACartThatIncludesTheAddedItems

	| a |
	
	a:= self anEmptyCart addItem: '11111' withQuantity: 1;
					  addItem: '22222' withQuantity: 3.

      self assert: (a quantityOf: '11111') = 1.
	self assert: (a quantityOf: '22222') = 3.


! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/17/2012 17:46'!
test03ACartShouldNotContainAnItemThatWasNotAddedToIt

	| a |

	a:= self anEmptyCart addItem: '11111' withQuantity: 1.
	self assert: (a quantityOf: '22222') = 0.



! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/17/2012 17:46'!
test04AddingTheSameItemMoreThanOnceToCartShouldReturnACartThatIncludesTheSumOfTheQuantitiesAddedForSuchItem

	| a |

	a:= self anEmptyCart addItem: '11111' withQuantity: 2;
                          addItem: '11111' withQuantity: 3. 
	self assert: (a quantityOf: '11111') = 5.



! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/18/2012 17:36'!
test05CanNotAddAnItemNotInTheCatalogToCart

	| cart |
	cart := self anEmptyCart.
	self should: [ cart addItem: 'INVALID_ITEM' withQuantity: 2 ]
		raise: Error
		withExceptionDo: [ :anException | self assert: anException messageText = ShoppingCart canNotAddItemNotInTheCatalogErrorMessage  ].

	self assert: cart isEmpty.
! !

!TusLibrosDotComTest methodsFor: 'Tests for ShoppingCart' stamp: 'GabrielFinkelstein 6/18/2012 17:37'!
test06CanNotAddAnItemWithNegativeQuantity

	| cart |
	cart := self anEmptyCart.
	self should: [ cart addItem: '11111' withQuantity: -1 ]
		raise: Error
		withExceptionDo: [ :anException | self assert: anException messageText = ShoppingCart canNotAddItemsWithNegativeQuantityErrorMessage ].

	self assert: cart isEmpty.
! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'MaximilianoBalmaceda 6/18/2012 21:48'!
test07CanNotCheckoutAnEmptyCart

	| salesBook cashier |
	salesBook := self aSalesBook.
	cashier := Cashier newWithMerchantProcessor: nil andSalesBook: salesBook.
	
	self
		should: [ Cashier new checkout: self anEmptyCart withCreditCard: self aValidCreditCard ]
		raise: Error
		withExceptionDo: [ :anException |
				self assert: anException messageText = Cashier canNotCheckoutAnEmptyCartErrorMessage.
				self assert: salesBook isEmpty.
			]! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'MaximilianoBalmaceda 6/18/2012 21:43'!
test08CanNotCheckoutWithExpiredCreditCard

	| cart salesBook cashier |
	cart := self anEmptyCart.
	salesBook := self aSalesBook.
	cashier := Cashier newWithMerchantProcessor: nil andSalesBook: salesBook.
	
	self
		should: [ self aCashier checkout: self aNonEmptyCart withCreditCard: self anExpiredCreditCard]
		raise: Error
		withExceptionDo: [ :anException |
			self assert: anException messageText = Cashier canNotCheckoutWithExpiredCardErrorMessage.
			self assert: salesBook isEmpty.
		].


! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'MaximilianoBalmaceda 6/18/2012 20:33'!
test09CashierShouldNotValidateCreditCardThroughMerchantProcessor
	"Hacemos checkout con una tarjeta vencida y con un Merchant Processor que siempre tira una excepcion,
	para asegurarnos que la cajera nunca llama al MP para validar la tarjeta"

	| cashier |
	cashier := Cashier newWithMerchantProcessor: ExceptionRaisingMerchantProcessor new andSalesBook: Set new.
	self
		should: [ cashier checkout: self aNonEmptyCart withCreditCard: self anExpiredCreditCard ]
		raise: Error
		withExceptionDo: [ :anException | self assert: anException messageText ~= ExceptionRaisingMerchantProcessor errorMessage ]! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/25/2012 01:58'!
test10CashierChargesCorrectAmount

	| salesRecord salesBook cashier cart creditCard |
	
	salesBook := self aSalesBook.
	cashier :=  Cashier newWithMerchantProcessor: StubMerchantProcessor new andSalesBook: salesBook.
	cart := self aNonEmptyCart.
	creditCard := self aValidCreditCard.
	
	salesRecord := SalesRecord newWithCustomer: creditCard ownerName andItems: cart contents andAmount: cart totalAmount.
	
	cashier checkout: cart withCreditCard: creditCard.
	
	self assert: (salesBook includes: salesRecord )


! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'MaximilianoBalmaceda 6/18/2012 21:49'!
test11CanNotCheckoutWithAStolenCreditCard

	| mp creditCard cart cashier salesBook |
	mp := StubMerchantProcessor new.
	creditCard := self aValidCreditCard.
	salesBook := self aSalesBook.
	
	mp addStolenCreditCard: creditCard.

	cashier :=  Cashier newWithMerchantProcessor: mp andSalesBook: salesBook.
	
	cart := self aNonEmptyCart.

	self should: [ cashier checkout: cart withCreditCard: creditCard ]
		raise: Error
		withExceptionDo: [	:anException | 
				self assert: anException messageText = StubMerchantProcessor stolenCreditCardErrorMessage.
				self assert: salesBook isEmpty.
			].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'MaximilianoBalmaceda 6/18/2012 21:51'!
test12CanNotCheckoutWithACreditCardWithoutFunds

	| mp creditCard cart cashier salesBook |
	mp := StubMerchantProcessor new.
	creditCard := self aValidCreditCard.
	salesBook := self aSalesBook.
	
	mp addCreditCardWithoutFunds: creditCard.

	cashier :=  Cashier newWithMerchantProcessor: mp andSalesBook: salesBook.
	
	cart := self aNonEmptyCart.

	self should: [ cashier checkout: cart withCreditCard: creditCard ]
		raise: Error
		withExceptionDo: [	:anException | 
				self assert: anException messageText = StubMerchantProcessor creditCardWithoutFundsErrorMessage.
				self assert: salesBook isEmpty.
			].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/27/2012 04:45'!
test13a_cannotCreateCartForInvalidUser

	| rest |
	rest := self restInterface.

	rest createCartWithClientId: '12xx345' andPassword: 'pwd12345' onSuccess: [ :aCartId | self fail ] onError: [ ].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/27/2012 04:47'!
test13b_cannotCreateCartForUserWithInvalidPassword

	| rest |
	rest := self restInterface.

	rest createCartWithClientId: '12345' andPassword: 'pwd12xx345' onSuccess: [ :aCartId | self fail ] onError: [ ].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/27/2012 04:46'!
test13c_createCartRequestReturnsAValidCartId

	| rest |
	rest := self restInterface.

	rest createCartWithClientId: '12345' andPassword: 'pwd12345' onSuccess: [ :aCartId | ] onError: [
			self fail.
		].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/27/2012 01:58'!
test14addToCartRequestAddsItemToCart

	| rest |
	rest := self restInterface.

	rest createCartWithClientId: '123456' andPassword: 'mypassword' onSuccess: [ :aCartId |
			rest addToCart: aCartId isbn: '11111' quantity: 1 onSuccess: [] onError: [
					self fail.
				].
		 ] onError: [ ].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/27/2012 04:40'!
test15listCartRequestListsCartItems

	| rest |
	rest := self restInterface.

	rest createCartWithClientId: '12345' andPassword: 'pwd12345' onSuccess: [ :aCartId |
		
			rest addToCart: aCartId isbn: '11111' quantity: 1 onSuccess: [
				
					rest listCart: aCartId onSuccess: [ :itemsBag |
							self assert: (itemsBag occurrencesOf: '11111') = 1.
							self assert: itemsBag size = 1.
													]
										onError: [ self fail ]
					
				] onError: [ self fail ].
				
		 ] onError: [ self fail ].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/27/2012 04:40'!
test16canNotAddToCartAfter30Minutes

	| stubClock rest |
	
	stubClock:= StubClock new.
	rest := self restInterfaceWithClock: stubClock.
	
	rest createCartWithClientId: '12345' andPassword: 'pwd12345' 
		onSuccess: [ :aCartId | stubClock dateAndTime: DateAndTime now + 31 minutes.
			                             rest addToCart: aCartId isbn: '11111' quantity: 1 
			                             		onSuccess: [ self fail ] 
			                             		onError: [	].
					 ] 
		onError: [ self fail].! !

!TusLibrosDotComTest methodsFor: 'Tests for Cashier' stamp: 'Balmaceda 6/27/2012 04:40'!
test17canNotListCartAfter30Minutes

	| stubClock rest |
	
	stubClock:= StubClock new.
	rest := self restInterfaceWithClock: stubClock.
	
	rest createCartWithClientId: '12345' andPassword: 'pwd12345' 
		onSuccess: [ :aCartId |  rest addToCart: aCartId isbn: '11111' quantity: 1 
			                             		onSuccess: [  stubClock dateAndTime: DateAndTime now + 31 minutes. 
						                                       rest listCart: aCartId 
						                                             onSuccess: [ :aCartContents | self fail ]
						                                             onError:[]
									  ] 
			                             		onError: [ self fail ].
					 ] 
		onError: [ self fail].! !

Object subclass: #Cashier
	instanceVariableNames: 'merchantProcessor salesRecordBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!Cashier class methodsFor: 'errors' stamp: 'GabrielFinkelstein 6/17/2012 17:41'!
canNotCheckoutAnEmptyCartErrorMessage

	^'Can not checkout an empty cart'! !

!Cashier class methodsFor: 'errors' stamp: 'GabrielFinkelstein 6/17/2012 17:52'!
canNotCheckoutWithExpiredCardErrorMessage

	^'Can not checkout with an expired credit card'! !

!Cashier class methodsFor: 'errors' stamp: 'MaximilianoBalmaceda 6/18/2012 20:33'!
newWithMerchantProcessor: aMerchantProcessor andSalesBook: aSalesBook
	^ self new initializeWithMerchantProcessor: aMerchantProcessor andSalesBook: aSalesBook
! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:22'!
checkout: aCart withCreditCard: aCreditCard

	| currentMonthOfYear salesRecord |
	currentMonthOfYear := MonthOfYear onMonthNumber: DateAndTime today month of: DateAndTime today year.
	
	(aCart isEmpty) ifTrue: [ self error: (self class canNotCheckoutAnEmptyCartErrorMessage ) ].

	(aCreditCard isExpiredOn: currentMonthOfYear) ifTrue: [ self error: (self class canNotCheckoutWithExpiredCardErrorMessage )].

	salesRecord := self generateSalesRecordFrom: aCart withCreditCard: aCreditCard.
	
	merchantProcessor debitFrom: aCreditCard amount: salesRecord amount onSuccess: [
			salesRecordBook add: salesRecord.
		].! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:20'!
generateSalesRecordFrom: aCart withCreditCard: aCreditCard

	^SalesRecord newWithCustomer: aCreditCard ownerName andItems: aCart contents andAmount: aCart totalAmount! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:25'!
initializeWithMerchantProcessor: aMerchantProcessor andSalesBook: aSalesBook

	merchantProcessor := aMerchantProcessor.
	salesRecordBook := aSalesBook.! !

Object subclass: #CreditCard
	instanceVariableNames: 'ownerName number expirationDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 11:49'!
invalidOwnerNameErrorDescription
	
	^ 'Owner name can not be empty'! !

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 11:47'!
ownedBy: anOwnerName identifiedBy: aNumber expiresOn: anExpirationDate 
	
	| trimmedOwnerName | 
	
	trimmedOwnerName := anOwnerName trimBoth.
	self validateOwnerName: trimmedOwnerName.
	
	^ self new initializeOwnedBy: trimmedOwnerName identifiedBy: aNumber expiresOn: anExpirationDate 
! !

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 11:48'!
validateOwnerName: trimmedOwnerName

	trimmedOwnerName isEmpty ifTrue: [ self error: self invalidOwnerNameErrorDescription ]! !

!CreditCard methodsFor: 'expiration' stamp: 'HernanWilkinson 6/7/2012 11:37'!
expirationDate

	^ expirationDate! !

!CreditCard methodsFor: 'initialization' stamp: 'HernanWilkinson 6/7/2012 11:36'!
initializeOwnedBy: anOwnerName identifiedBy: aNumber expiresOn: anExpirationDate 
	
	ownerName := anOwnerName.
	number := aNumber.
	expirationDate := anExpirationDate! !

!CreditCard methodsFor: 'expiration' stamp: 'HernanWilkinson 6/7/2012 12:02'!
isExpiredOn: aMonthOfYear 
	
	^ aMonthOfYear > expirationDate ! !

!CreditCard methodsFor: 'number' stamp: 'HernanWilkinson 6/7/2012 11:34'!
number
	^ number! !

!CreditCard methodsFor: 'owner' stamp: 'HernanWilkinson 6/7/2012 11:34'!
ownerName
	^ ownerName! !

Object subclass: #ExceptionRaisingMerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!ExceptionRaisingMerchantProcessor class methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/18/2012 17:46'!
errorMessage

	^'Talking to merchant processor'.! !

!ExceptionRaisingMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 20:55'!
debitFrom: aCreditCard amount: anNumber onSuccess: aBlock

	^self error: (self class errorMessage).
! !

Object subclass: #RESTInterface
	instanceVariableNames: 'catalogue carts accessTimes clock registeredUsers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!RESTInterface class methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 04:23'!
newWithCatalogue: aCatalogue andClock: aClock andRegisteredUsers: aRegisteredUsersCollection

	^self new initializeWithCatalogue: aCatalogue andClock: aClock andRegisteredUsers: aRegisteredUsersCollection.! !

!RESTInterface methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 04:15'!
addToCart: aCartId isbn: anIsbn quantity: aNumber onSuccess: successBlock onError: errorBlock

	| cart |

	cart:= self retrieveValidCart: aCartId onError:[^errorBlock value].

	cart addItem: anIsbn withQuantity: aNumber.
	
	successBlock value.! !

!RESTInterface methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 04:38'!
createCartWithClientId: aClientId andPassword: aPassword onSuccess: successBlock onError: errorBlock

	| cart |
	
	(registeredUsers includesKey: aClientId) ifFalse:[^errorBlock value].
	
	(registeredUsers at:aClientId) = aPassword ifFalse:[^errorBlock value].
	
	cart := ShoppingCart newWithCatalogue: catalogue.

	carts at: aClientId put: cart.

	accessTimes at: aClientId put: (clock now).
	
	successBlock value: aClientId.! !

!RESTInterface methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 04:24'!
initializeWithCatalogue: aCatalogue andClock: aClock andRegisteredUsers: aRegisteredUsersCollection

	carts := Dictionary new.
	catalogue := aCatalogue.
	accessTimes := Dictionary new.
	clock := aClock.
	registeredUsers := aRegisteredUsersCollection.! !

!RESTInterface methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 03:33'!
isCartExpired: aCartId 

| delta a b|

a:= clock now.
b:=  accessTimes at: aCartId.
delta := (a - b) minutes.
^(delta > 30)! !

!RESTInterface methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 04:17'!
listCart: aCartId onSuccess: successBlock onError: errorBlock

	| cart |
	
	cart:= self retrieveValidCart: aCartId onError:[^errorBlock value].
	
	successBlock value: cart contents.! !

!RESTInterface methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 04:09'!
retrieveValidCart: aCartId onError:errorBlock.
	
	(self isCartExpired: aCartId) ifTrue: [ ^errorBlock value ].
	
	^carts at: aCartId.
	
! !

Object subclass: #SalesRecord
	instanceVariableNames: 'amount items customer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!SalesRecord class methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:12'!
newWithCustomer: aString andItems: aCollection andAmount: aNumber

	^self new initializeCustomer: aString andItems: aCollection andAmount: aNumber! !

!SalesRecord methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:29'!
= aSalesRecord

	^customer = aSalesRecord customer & items = aSalesRecord items & amount = aSalesRecord amount.! !

!SalesRecord methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:19'!
amount

	^amount.! !

!SalesRecord methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:19'!
customer

	^customer.! !

!SalesRecord methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:29'!
hash

	^customer hash bitXor: items hash; bitXor: amount hash.! !

!SalesRecord methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:12'!
initializeCustomer: aString andItems: aCollection andAmount: aNumber

	customer := aString.
	items := aCollection.
	amount := aNumber.! !

!SalesRecord methodsFor: 'as yet unclassified' stamp: 'MaximilianoBalmaceda 6/18/2012 21:19'!
items

	^items.! !

Object subclass: #ShoppingCart
	instanceVariableNames: 'catalogue contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!ShoppingCart class methodsFor: 'errors' stamp: 'GabrielFinkelstein 6/17/2012 17:38'!
canNotAddItemNotInTheCatalogErrorMessage

	^'Can not add items that are not in the catalog to a cart'
! !

!ShoppingCart class methodsFor: 'errors' stamp: 'GabrielFinkelstein 6/17/2012 17:39'!
canNotAddItemsWithNegativeQuantityErrorMessage

	^'Can not add items with negative quantity to a cart'! !

!ShoppingCart class methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/17/2012 18:52'!
newWithCatalogue: aCatalogue

	^self new initializeWithCatalogue: aCatalogue! !

!ShoppingCart methodsFor: 'initializing' stamp: 'MaximilianoBalmaceda 6/18/2012 20:47'!
addItem: anItem withQuantity: anInteger

	(catalogue includesKey: anItem) ifFalse: [^self error: (self class canNotAddItemNotInTheCatalogErrorMessage) ].
	
	(anInteger > 0) ifFalse: [^self error: (self class canNotAddItemsWithNegativeQuantityErrorMessage) ].
	
	contents add: anItem withOccurrences: anInteger.

! !

!ShoppingCart methodsFor: 'initializing' stamp: 'MaximilianoBalmaceda 6/18/2012 20:40'!
contents

	^contents copy.! !

!ShoppingCart methodsFor: 'initializing' stamp: 'GabrielFinkelstein 6/17/2012 18:52'!
initializeWithCatalogue: aCatalogue

	contents:= Bag new.
	catalogue:= aCatalogue.! !

!ShoppingCart methodsFor: 'accesing' stamp: 'GabrielFinkelstein 6/17/2012 17:13'!
isEmpty

	^contents isEmpty.

! !

!ShoppingCart methodsFor: 'accesing' stamp: 'GabrielFinkelstein 6/12/2012 21:49'!
quantityOf: anItem

	^contents occurrencesOf: anItem.

! !

!ShoppingCart methodsFor: 'initializing' stamp: 'MaximilianoBalmaceda 6/18/2012 20:44'!
totalAmount

	| amount |
	amount := 0.
	contents do: [ :anItem |
			amount := amount + (catalogue at: anItem)
		].
	^amount.! !

Object subclass: #StubClock
	instanceVariableNames: 'dateAndTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!StubClock methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 02:44'!
dateAndTime: aDateAndTime

dateAndTime:= aDateAndTime.! !

!StubClock methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 02:45'!
initialize

dateAndTime:= DateAndTime now.! !

!StubClock methodsFor: 'as yet unclassified' stamp: 'Balmaceda 6/27/2012 03:22'!
now

^dateAndTime.! !

Object subclass: #StubMerchantProcessor
	instanceVariableNames: 'stolenCreditCards withoutFundsCreditCards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibrosDotCom'!

!StubMerchantProcessor class methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/24/2012 15:16'!
creditCardWithoutFundsErrorMessage

	^'The credit card you are trying to use has not enough funds'! !

!StubMerchantProcessor class methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/24/2012 15:15'!
stolenCreditCardErrorMessage

	^'The credit card you are trying to use has been reported as stolen'! !

!StubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/24/2012 15:18'!
addCreditCardWithoutFunds: aCreditCard 

	withoutFundsCreditCards add: aCreditCard.! !

!StubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/24/2012 15:11'!
addStolenCreditCard: aCreditCard 
	
	stolenCreditCards add: aCreditCard.! !

!StubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/24/2012 15:17'!
debitFrom: aCreditCard amount: anNumber onSuccess: aBlock

	(stolenCreditCards includes: aCreditCard ) ifTrue: [ self error: self class stolenCreditCardErrorMessage ].
	(withoutFundsCreditCards includes: aCreditCard ) ifTrue: [ self error: self class creditCardWithoutFundsErrorMessage ].
	aBlock value.
! !

!StubMerchantProcessor methodsFor: 'as yet unclassified' stamp: 'GabrielFinkelstein 6/24/2012 15:12'!
initialize

	stolenCreditCards := Set new.
	withoutFundsCreditCards := Set new.! !
